'use strict';













var _jestUtil = require('jest-util');





var _jestConfig = require('jest-config');
var _package = require('../../package.json');
var _args = require('./args');var _args2 = _interopRequireDefault(_args);
var _chalk = require('chalk');var _chalk2 = _interopRequireDefault(_chalk);
var _create_context = require('../lib/create_context');var _create_context2 = _interopRequireDefault(_create_context);
var _get_changed_files_promise = require('../get_changed_files_promise');var _get_changed_files_promise2 = _interopRequireDefault(_get_changed_files_promise);
var _get_jest = require('./get_jest');var _get_jest2 = _interopRequireDefault(_get_jest);
var _handle_deprecation_warnings = require('../lib/handle_deprecation_warnings');var _handle_deprecation_warnings2 = _interopRequireDefault(_handle_deprecation_warnings);
var _log_debug_messages = require('../lib/log_debug_messages');var _log_debug_messages2 = _interopRequireDefault(_log_debug_messages);
var _pre_run_message = require('../pre_run_message');var _pre_run_message2 = _interopRequireDefault(_pre_run_message);
var _run_jest = require('../run_jest');var _run_jest2 = _interopRequireDefault(_run_jest);
var _jestRuntime = require('jest-runtime');var _jestRuntime2 = _interopRequireDefault(_jestRuntime);
var _test_watcher = require('../test_watcher');var _test_watcher2 = _interopRequireDefault(_test_watcher);
var _watch = require('../watch');var _watch2 = _interopRequireDefault(_watch);
var _yargs = require('yargs');var _yargs2 = _interopRequireDefault(_yargs);function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { default: obj };}function _asyncToGenerator(fn) {return function () {var gen = fn.apply(this, arguments);return new Promise(function (resolve, reject) {function step(key, arg) {try {var info = gen[key](arg);var value = info.value;} catch (error) {reject(error);return;}if (info.done) {resolve(value);} else {return Promise.resolve(value).then(function (value) {step("next", value);}, function (err) {step("throw", err);});}}return step("next");});};} /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           * Copyright (c) 2014, Facebook, Inc. All rights reserved.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           * This source code is licensed under the BSD-style license found in the
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           * LICENSE file in the root directory of this source tree. An additional grant
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           * of patent rights can be found in the PATENTS file in the same directory.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           * 
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           */function run(maybeArgv, project) {const argv = _buildArgv(maybeArgv, project);const projects = _getProjectListFromCLIArgs(argv, project); // If we're running a single Jest project, we might want to use another
  // version of Jest (the one that is specified in this project's package.json)
  const runCLIFn = _getRunCLIFn(projects);runCLIFn(argv, projects, result => _readResultsAndExit(argv, result));}

const runCLI = (() => {var _ref = _asyncToGenerator(function* (
  argv,
  projects,
  onComplete)
  {
    // Optimize 'fs' module and make it more compatible with multiple platforms.
    _patchGlobalFSModule();

    // If we output a JSON object, we can't write anything to stdout, since
    // it'll break the JSON structure and it won't be valid.
    const outputStream = argv.json ? process.stderr : process.stdout;

    argv.version && _printVersionAndExit(outputStream, onComplete);

    try {var _getConfigs2 =
      _getConfigs(
      projects,
      argv,
      outputStream);const globalConfig = _getConfigs2.globalConfig,configs = _getConfigs2.configs,hasDeprecationWarnings = _getConfigs2.hasDeprecationWarnings;

      yield _run(
      globalConfig,
      configs,
      hasDeprecationWarnings,
      outputStream,
      onComplete);

    } catch (error) {
      _printErrorAndExit(error);
    }
  });return function runCLI(_x, _x2, _x3) {return _ref.apply(this, arguments);};})();

const _printErrorAndExit = error => {
  (0, _jestUtil.clearLine)(process.stderr);
  (0, _jestUtil.clearLine)(process.stdout);
  console.error(_chalk2.default.red(error.stack));
  process.exit(1);
};

const _readResultsAndExit = (argv, result) => {
  const code = !result || result.success ? 0 : 1;
  process.on('exit', () => process.exit(code));
  if (argv && argv.forceExit) {
    process.exit(code);
  }
};

const _buildArgv = (maybeArgv, project) => {
  const argv = (0, _yargs2.default)(maybeArgv || process.argv.slice(2)).
  usage(_args2.default.usage).
  help().
  alias('help', 'h').
  options(_args2.default.options).
  epilogue(_args2.default.docs).
  check(_args2.default.check).argv;

  (0, _jestUtil.validateCLIOptions)(argv, _args2.default.options);

  return argv;
};

const _getProjectListFromCLIArgs = (argv, project) => {
  const projects = argv.projects ? argv.projects : [];

  if (project) {
    projects.push(project);
  }

  if (!projects.length) {
    projects.push(process.cwd());
  }

  return projects;
};

const _getRunCLIFn = projects =>
projects.length === 1 ? (0, _get_jest2.default)(projects[0]).runCLI : runCLI;

const _printDebugInfoAndExitIfNeeded = (
argv,
globalConfig,
config,
outputStream) =>
{
  if (argv.debug || argv.showConfig) {
    (0, _log_debug_messages2.default)(globalConfig, config, outputStream);
  }
  if (argv.showConfig) {
    process.exit(0);
  }
};

const _printVersionAndExit = (outputStream, onComplete) => {
  outputStream.write(`v${_package.version}\n`);
  onComplete && onComplete();
  return;
};

// Possible scenarios:
//  1. jest --config config.json
//  2. jest --projects p1 p2
//  3. jest --projects p1 p2 --config config.json
//  4. jest --projects p1
//  5. jest
//
// If no projects are specified, process.cwd() will be used as the default
// (and only) project.
const _getConfigs = (
projectsFromCLIArgs,
argv,
outputStream) =>




{
  let globalConfig;
  let hasDeprecationWarnings;
  let configs = [];
  let projects = projectsFromCLIArgs;

  if (projectsFromCLIArgs.length === 1) {
    const parsedConfig = (0, _jestConfig.readConfig)(argv, projects[0]);

    if (parsedConfig.globalConfig.projects) {
      // If this was a single project, and its config has `projects`
      // settings, use that value instead.
      projects = parsedConfig.globalConfig.projects;
    }

    hasDeprecationWarnings = parsedConfig.hasDeprecationWarnings;
    globalConfig = parsedConfig.globalConfig;
    configs = [parsedConfig.config];
    if (globalConfig.projects && globalConfig.projects.length) {
      // Even though we had one project in CLI args, there might be more
      // projects defined in the config.
      projects = globalConfig.projects;
    }
  }

  if (projects.length > 1) {
    const parsedConfigs = projects.map(root => (0, _jestConfig.readConfig)(argv, root, true));
    configs = parsedConfigs.map((_ref2) => {let config = _ref2.config;return config;});
    if (!hasDeprecationWarnings) {
      hasDeprecationWarnings = parsedConfigs.some(
      (_ref3) => {let hasDeprecationWarnings = _ref3.hasDeprecationWarnings;return !!hasDeprecationWarnings;});

    }
    // If no config was passed initially, use the one from the first project
    if (!globalConfig) {
      globalConfig = parsedConfigs[0].globalConfig;
    }
  }

  if (!globalConfig || !configs.length) {
    throw new Error('jest: No configuration found for any project.');
  }

  _printDebugInfoAndExitIfNeeded(argv, globalConfig, configs[0], outputStream);

  return {
    configs,
    globalConfig,
    hasDeprecationWarnings: !!hasDeprecationWarnings };

};

const _patchGlobalFSModule = () => {
  const realFs = require('fs');
  const fs = require('graceful-fs');
  fs.gracefulify(realFs);
};

const _buildContextsAndHasteMaps = (() => {var _ref4 = _asyncToGenerator(function* (
  configs,
  globalConfig,
  outputStream)
  {
    const hasteMapInstances = Array(configs.length);
    const contexts = yield Promise.all(
    configs.map((() => {var _ref5 = _asyncToGenerator(function* (config, index) {
        (0, _jestUtil.createDirectory)(config.cacheDirectory);
        const hasteMapInstance = _jestRuntime2.default.createHasteMap(config, {
          console: new _jestUtil.Console(outputStream, outputStream),
          maxWorkers: globalConfig.maxWorkers,
          resetCache: !config.cache,
          watch: globalConfig.watch,
          watchman: globalConfig.watchman });

        hasteMapInstances[index] = hasteMapInstance;
        return (0, _create_context2.default)(config, (yield hasteMapInstance.build()));
      });return function (_x7, _x8) {return _ref5.apply(this, arguments);};})()));


    return { contexts, hasteMapInstances };
  });return function _buildContextsAndHasteMaps(_x4, _x5, _x6) {return _ref4.apply(this, arguments);};})();

const _run = (() => {var _ref6 = _asyncToGenerator(function* (
  globalConfig,
  configs,
  hasDeprecationWarnings,
  outputStream,
  onComplete)
  {
    // Queries to hg/git can take a while, so we need to start the process
    // as soon as possible, so by the time we need the result it's already there.
    const changedFilesPromise = (0, _get_changed_files_promise2.default)(globalConfig, configs);var _ref7 =
    yield _buildContextsAndHasteMaps(
    configs,
    globalConfig,
    outputStream);const contexts = _ref7.contexts,hasteMapInstances = _ref7.hasteMapInstances;


    globalConfig.watch || globalConfig.watchAll ?
    yield _runWatch(
    contexts,
    configs,
    hasDeprecationWarnings,
    globalConfig,
    outputStream,
    hasteMapInstances,
    changedFilesPromise) :

    yield _runWithoutWatch(
    globalConfig,
    contexts,
    outputStream,
    onComplete,
    changedFilesPromise);

  });return function _run(_x9, _x10, _x11, _x12, _x13) {return _ref6.apply(this, arguments);};})();

const _runWatch = (() => {var _ref8 = _asyncToGenerator(function* (
  contexts,
  configs,
  hasDeprecationWarnings,
  globalConfig,
  outputStream,
  hasteMapInstances,
  changedFilesPromise)
  {
    if (hasDeprecationWarnings) {
      try {
        yield (0, _handle_deprecation_warnings2.default)(outputStream, process.stdin);
        return (0, _watch2.default)(globalConfig, contexts, outputStream, hasteMapInstances);
      } catch (e) {
        process.exit(0);
      }
    }

    return (0, _watch2.default)(globalConfig, contexts, outputStream, hasteMapInstances);
  });return function _runWatch(_x14, _x15, _x16, _x17, _x18, _x19, _x20) {return _ref8.apply(this, arguments);};})();

const _runWithoutWatch = (() => {var _ref9 = _asyncToGenerator(function* (
  globalConfig,
  contexts,
  outputStream,
  onComplete,
  changedFilesPromise)
  {
    const startRun = (() => {var _ref10 = _asyncToGenerator(function* () {
        if (!globalConfig.listTests) {
          _pre_run_message2.default.print(outputStream);
        }
        return yield (0, _run_jest2.default)({
          changedFilesPromise,
          contexts,
          globalConfig,
          onComplete,
          outputStream,
          startRun,
          testWatcher: new _test_watcher2.default({ isWatchMode: false }) });

      });return function startRun() {return _ref10.apply(this, arguments);};})();
    return yield startRun();
  });return function _runWithoutWatch(_x21, _x22, _x23, _x24, _x25) {return _ref9.apply(this, arguments);};})();

module.exports = {
  run,
  runCLI };